Package org.eclipse.cdt.core.dom.ast.cpp

## Interface ICPPASTBinaryExpression

All Superinterfaces:
  `IASTBinaryExpression`, `IASTExpression`, `IASTImplicitDestructorNameOwner`, `IASTImplicitNameOwner`, `IASTInitializerClause`, `IASTNode`, `ICPPASTExpression`, `ICPPASTInitializerClause`

All Known Subinterfaces:
  `IGPPASTBinaryExpression`

    public interface ICPPASTBinaryExpression
    extends IASTBinaryExpression, ICPPASTExpression, IASTImplicitNameOwner

C++ adds a few more binary expressions over C.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

### Field Summary

Fields
`static int` `op_pmarrow` `op_pmarrow` pointer-to-member pointer dereference.
`static int` `op_pmdot` `op_pmdot` pointer-to-member field dereference.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTBinaryExpression

`op_assign, op_binaryAnd, op_binaryAndAssign, op_binaryOr, op_binaryOrAssign, op_binaryXor, op_binaryXorAssign, op_divide, op_divideAssign, op_ellipses, op_equals, op_greaterEqual, op_greaterThan, op_lessEqual, op_lessThan, op_logicalAnd, op_logicalOr, op_max, op_min, op_minus, op_minusAssign, op_modulo, op_moduloAssign, op_multiply, op_multiplyAssign, op_notequals, op_plus, op_plusAssign, op_shiftLeft, op_shiftLeftAssign, op_shiftRight, op_shiftRightAssign, OPERAND_ONE, OPERAND_TWO`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`IMPLICIT_DESTRUCTOR_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitNameOwner

`IMPLICIT_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Method Summary

All Methods Instance Methods Abstract Methods
`ICPPASTBinaryExpression` `copy()` Returns a mutable copy of the tree rooted at this node.
`ICPPASTBinaryExpression` `copy​(IASTNode.CopyStyle style)` Returns a mutable copy of the tree rooted at this node.
`ICPPFunction` `getOverload()` Returns the function binding for the overloaded operator, or `null` if the operator is not overloaded.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTBinaryExpression

`getInitOperand2, getOperand1, getOperand2, getOperator, setOperand1, setOperand2, setOperator`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`getImplicitDestructorNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitNameOwner

`getImplicitNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.cpp.ICPPASTInitializerClause

`getEvaluation`

### Field Detail

#### op_pmdot

    static final int op_pmdot

`op_pmdot` pointer-to-member field dereference.

See Also:
  Constant Field Values

#### op_pmarrow

    static final int op_pmarrow

`op_pmarrow` pointer-to-member pointer dereference.

See Also:
  Constant Field Values

### Method Detail

#### copy

    ICPPASTBinaryExpression copy()

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTBinaryExpression`
Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

#### copy

    ICPPASTBinaryExpression copy​(IASTNode.CopyStyle style)

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTBinaryExpression`
Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3

#### getOverload

    ICPPFunction getOverload()

Returns the function binding for the overloaded operator, or `null` if the operator is not overloaded.

Since:
  5.3